DECLARE FUNCTION DaysBetweenDates& (dat1$, dat2$)
DECLARE FUNCTION Julian2Date$ (julian&)
DECLARE FUNCTION MDY2Date$ (month%, Day%, year%)
DECLARE FUNCTION MonthName$ (dat$)
DECLARE FUNCTION Date2Julian& (dat$)
DECLARE FUNCTION Date2Year% (dat$)
DECLARE FUNCTION Date2Day% (dat$)
DECLARE FUNCTION Date2Month% (dat$)
DECLARE FUNCTION DayOfTheWeek$ (dat$)
DECLARE FUNCTION Copyright$ (Logo$)
DECLARE FUNCTION TimeDate2Second& (tim$, dat$)
CONST FALSE = 0
CONST TRUE = NOT FALSE
PRINT Copyright$(Logo$): PRINT
'
'*Note*  This program requires Microsoft PDS v? to set DOS ERRORLEVEL
'
tim$ = "02:00:00"
FOR i = 1 TO 7
   dat$ = "04-0" + LTRIM$(STR$(i)) + "-" + RIGHT$(DATE$, 4)
   IF DayOfTheWeek$(dat$) = "Sunday" THEN
      LowerLimit& = TimeDate2Second&(tim$, dat$)
      EXIT FOR
   END IF
NEXT

FOR i = 25 TO 31
   dat$ = "10-" + LTRIM$(STR$(i)) + "-" + RIGHT$(DATE$, 4)
   IF DayOfTheWeek$(dat$) = "Sunday" THEN
      UpperLimit& = TimeDate2Second&(tim$, dat$)
      EXIT FOR
   END IF
NEXT

dat$ = DATE$
tim$ = TIME$

PRINT "Daylight Savings time is ";

IF TimeDate2Second&(tim$, dat$) > LowerLimit& THEN
   IF TimeDate2Second&(tim$, dat$) < UpperLimit& THEN
      DayLightSavings = 1
   ELSE
      PRINT "NOT ";
      DayLightSavings = 0
   END IF
ELSE
   PRINT "NOT ";
   DayLightSavings = 0
END IF

PRINT "in effect."
PRINT
PRINT "Exit with DOS ERRORLEVEL"; DayLightSavings

END DayLightSavings

FUNCTION Copyright$ (Logo$)
'032 sp  033 !  034 "  035 #  036 $  037 %  038 &  039 '  040 (  041 )  042 *
'043 +   044 ,  045 -  046 .  047 /  048 0  049 1  050 2  051 3  052 4  053 5
'054 6   055 7  056 8  057 9  058 :  059 ;  060 <  061 =  062 >  063 ?  064 @
'065 A   066 B  067 C  068 D  069 E  070 F  071 G  072 H  073 I  074 J  075 K
'076 L   077 M  078 N  079 O  080 P  081 Q  082 R  083 S  084 T  085 U  086 V
'087 W   088 X  089 Y  090 Z  091 [  092 \  093 ]  094 ^  095 _  096 `  097 a
'098 b   099 c  100 d  101 e  102 f  103 g  104 h  105 i  106 j  107 k  108 l
'109 m   110 n  111 o  112 p  113 q  114 r  115 s  116 t  117 u  118 v  119 w
'120 x   121 y  122 z  123 {  124 |  125 }  126 ~      program name
'          D         S          T          -          N           O          W
c$ = CHR$(68) + CHR$(83) + CHR$(84) + CHR$(45) + CHR$(78) + CHR$(79) + CHR$(87) + CHR$(32)
'            N         D        E         R         sp                 v
'c$ = c$ + CHR$(78) + CHR$(68) + CHR$(69) + CHR$(82) + CHR$(32) + CHR$(118)
'              1           .          0
c$ = c$ + CHR$(49) + CHR$(46) + CHR$(48)
'                       b         y                    R         i          c
c$ = c$ + CHR$(32) + CHR$(98) + CHR$(121) + CHR$(32) + CHR$(82) + CHR$(105) + CHR$(99)
'                h          a         r         d
c$ = c$ + CHR$(104) + CHR$(97) + CHR$(114) + CHR$(100)
     '                P         .                   K          l
c$ = c$ + CHR$(32) + CHR$(80) + CHR$(46) + CHR$(32) + CHR$(75) + CHR$(108)
     '      e          i         n          ,
c$ = c$ + CHR$(101) + CHR$(105) + CHR$(110) + CHR$(44)
'                     (         C         )                   C
c$ = c$ + CHR$(32) + CHR$(40) + CHR$(67) + CHR$(41) + CHR$(32) + CHR$(67)
'           o         p          y         r           i         g
c$ = c$ + CHR$(111) + CHR$(112) + CHR$(121) + CHR$(114) + CHR$(105) + CHR$(103)
'           h         t                    1         9         9
c$ = c$ + CHR$(104) + CHR$(116) + CHR$(32) + CHR$(49) + CHR$(57) + CHR$(57)
'           3         ,
c$ = c$ + CHR$(51) + CHR$(44) + CHR$(32) + CHR$(65)
'            l          l                    r          i          g
c$ = c$ + CHR$(108) + CHR$(108) + CHR$(32) + CHR$(114) + CHR$(105) + CHR$(103)
'            h          t           s                   r           e
c$ = c$ + CHR$(104) + CHR$(116) + CHR$(115) + CHR$(32) + CHR$(114) + CHR$(101)
'            s          e           r         v          e           d
c$ = c$ + CHR$(115) + CHR$(101) + CHR$(114) + CHR$(118) + CHR$(101) + CHR$(100)
'           .
c$ = c$ + CHR$(46)
'
Copyright$ = c$
'
END FUNCTION

FUNCTION Date2Day% (dat$) STATIC
' ********************************************
' **  Name:      Date2Day%                  **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the day number given a date in the
' QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:       day% = Date2Day%(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION Date2Day%(dat$)

    Date2Day% = VAL(MID$(dat$, 4, 2))
END FUNCTION

FUNCTION Date2Julian& (dat$) STATIC

' ********************************************
' **  Name:      Date2Julian&               **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the astronomical julian day number given a
' date in the QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:               j& = Date2Julian&(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            month%          Month number for given date
'                       day%            Day number for given date
'                       year%           Year number for given date
'                       ta&             First term of the Julian day number calculation
'                       tb&             Second term of the Julian day number calculation
'                       tc&             Third term of the Julian day number calculation
' MODULE LEVEL
'       DECLARATIONS:
'
'
'                       DECLARE FUNCTION Date2Day% (dat$)
'                       DECLARE FUCNTION Date2Julian& (dat$)
'                       DECLARE FUNCTION Date2Month% (dat$)
'                       DECLARE FUNCTION Date2Year% (dat$)
'

	month% = Date2Month%(dat$)
	Day% = Date2Day%(dat$)
	year% = Date2Year%(dat$)
	IF year% < 1583 THEN
		PRINT "Date2Julian: Year is less than 1583"
		SYSTEM
	END IF
	IF month% > 2 THEN
		month% = month% - 3
	ELSE
		month% = month% + 9
		year% = year% - 1
	END IF
	ta& = 146097 * (year% \ 100) \ 4
	tb& = 1461& * (year% MOD 100) \ 4
	tc& = (153 * month% + 2) \ 5 + Day% + 1721119
	Date2Julian& = ta& + tb& + tc&
END FUNCTION

FUNCTION Date2Month% (dat$) STATIC
' ********************************************
' **  Name:      Date2Month%                **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the month number given a date in the
' QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:       month% = Date2Month%(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION Date2Month%(dat$)

	Date2Month% = VAL(MID$(dat$, 1, 2))
END FUNCTION

FUNCTION Date2Year% (dat$) STATIC
' ********************************************
' **  Name:      Date2Year%                 **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the year number given a date in the
' QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:       year% = Date2Year%(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION Date2Year%(dat$)
	Date2Year% = VAL(MID$(dat$, 7))
END FUNCTION

FUNCTION DayOfTheWeek$ (dat$) STATIC
' ********************************************
' **  Name:      DayOfTheWeek$              **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the string stating the day of the week.
' Input is a date expressed in the QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:       PRINT "The day of the week is "; DayOfTheWeek$(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION DayOfTheWeek$(dat$)
	SELECT CASE Date2Julian&(dat$) MOD 7
	CASE 0
		DayOfTheWeek$ = "Monday"
	CASE 1
		DayOfTheWeek$ = "Tuesday"
	CASE 2
		DayOfTheWeek$ = "Wednesday"
	CASE 3
		DayOfTheWeek$ = "Thursday"
	CASE 4
		DayOfTheWeek$ = "Friday"
	CASE 5
		DayOfTheWeek$ = "Saturday"
	CASE 6
		DayOfTheWeek$ = "Sunday"
	END SELECT
END FUNCTION

FUNCTION DaysBetweenDates& (dat1$, dat2$) STATIC
' ********************************************
' **  Name:      DaysBetweenDates&          **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the number of days between any two dates.
'
' EXAMPLE OF USE:       days& = DaysBetweenDates&(dat1$, dat2$)
' PARAMETERS:           dat1$           First date
'                       dat2$           Second date
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION DaysBetweenDates& (dat1$, dat2$)
	DaysBetweenDates& = ABS(Date2Julian&(dat1$) - Date2Julian&(dat2$))
END FUNCTION

FUNCTION Julian2Date$ (julian&) STATIC
' ********************************************
' **  Name:      Julian2Date$               **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns a date in the QuickBASIC string format
' MM-DD-YYYY as calculated from a Julian day number.
'
' EXAMPLE OF USE:       PRINT "Date for the given Julian number is "; Julian2Date$(j&)
' PARAMETERS:           j&              Julian day number
' VARIABLES:            x&              Temporary calculation variable
'                       y&              Temporary calculation variable
'                       d&              Day number in long interger form
'                       m&              Month number before adjustment
'                       month%          Month number
'                       year%           Year number
'                       day%            Day number
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION Julian2Date$ (julian&)

	x& = 4 * julian& - 6884477
	y& = (x& \ 146097) * 100
	d& = (x& MOD 146097) \ 4

	x& = 4 * d& + 3
	y& = (x& \ 1461) + y&
	d& = (x& MOD 1461) \ 4 + 1

	x& = 5 * d& - 3
	m& = x& \ 153 + 1
	d& = (x& MOD 153) \ 5 + 1

	IF m& < 11 THEN
		month% = m& + 2
	ELSE
		month% = m& - 10
	END IF
	Day% = d&
	year% = y& + m& \ 11

	dat$ = MDY2Date$(month%, Day%, year%)
	Julian2Date$ = dat$
END FUNCTION

FUNCTION MDY2Date$ (month%, Day%, year%) STATIC
' ********************************************
' **  Name:      MDY2Date$                  **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Converts month%, day%, year%, to a date string
' in the QuickBASIC string format MM-DD-YYYY.
'
' EXAMPLE OF USE:       dat$ = MDY2Date$(month%, day%, year%)
' PARAMETERS:           month%          Month for the date
'                       day%            Day of the month
'                       year%           Year number
' VARIABLES:            y$              Temporary year string
'                       m$              Temporary month string
'                       d$              Temporary day string
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION MDY2Date$ (month%, day%, year%)

	y$ = RIGHT$("000" + MID$(STR$(year%), 2), 4)
	m$ = RIGHT$("0" + MID$(STR$(month%), 2), 2)
	d$ = RIGHT$("0" + MID$(STR$(Day%), 2), 2)
	MDY2Date$ = m$ + "-" + d$ + "-" + y$
END FUNCTION

FUNCTION MonthName$ (dat$) STATIC
' ********************************************
' **  Name:      MonthName$                 **
' **  Type:      Function                   **
' **  Module:    CALENDAR.BAS               **
' **  Language:  Microsoft QuickBASIC 4.00  **
' ********************************************
'
' Returns the string stating the month as indicated
' in dat$ (QuickBASIC string format MM-DD-YYYY).
'
' EXAMPLE OF USE:       PRINT MonthName$(dat$)
' PARAMETERS:           dat$            Date of concern
' VARIABLES:            none
' MODULE LEVEL
'       DECLARATIONS:
'                       DECLARE FUNCTION MonthName$ (dat$)


	IF LEN(dat$) <> 10 THEN
		dat$ = "MM-DD-YYYY"
	END IF

	SELECT CASE LEFT$(dat$, 2)
	CASE "01"
		MonthName$ = "January"
	CASE "02"
		MonthName$ = "February"
	CASE "03"
		MonthName$ = "March"
	CASE "04"
		MonthName$ = "April"
	CASE "05"
		MonthName$ = "May"
	CASE "06"
		MonthName$ = "June"
	CASE "07"
		MonthName$ = "July"
	CASE "08"
		MonthName$ = "August"
	CASE "09"
		MonthName$ = "September"
	CASE "10"
		MonthName$ = "October"
	CASE "11"
		MonthName$ = "November"
	CASE "12"
		MonthName$ = "December"
	CASE ELSE
		MonthName$ = "?MonthName?"
	END SELECT
END FUNCTION

FUNCTION TimeDate2Second& (tim$, dat$) STATIC
	days& = Date2Julian&(dat$) - 2444240
	hour% = VAL(LEFT$(tim$, 2))
	minute% = VAL(MID$(tim$, 4, 2))
	second% = VAL(RIGHT$(tim$, 2))
	secs& = CLNG(hour%) * 3600 + minute% * 60 + second%
	IF days& >= 0 AND days& < 24857 THEN
		TimeDate2Second& = days& * 86400 + secs&
	ELSE
		PRINT "TimeDate2Second: not in range 1980 to 2047"
		SYSTEM
	END IF
END FUNCTION

